<template>
  <div class="task-apply-manage">
    <div class="part-box part-box-filter part-box-flex">
      <el-form ref="FilterForm" label-position="left" label-width="85px" inline>
        <template v-if="checkPrivilege('condition', 'condition')">
          <el-form-item label="学期：">
            <semester-select v-model="filter.semesterId"></semester-select>
          </el-form-item>
          <el-form-item label="考试：">
            <exam-select
              v-model="filter.examId"
              :semester-id="filter.semesterId"
            ></exam-select>
          </el-form-item>
          <el-form-item label="审核状态：">
            <el-select
              v-model="filter.auditStatus"
              style="width: 142px;"
              placeholder="审核状态"
              clearable
            >
              <el-option
                v-for="(val, key) in AUDITING_STATUS"
                :key="key"
                :value="key"
                :label="val"
              ></el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="课程（代码）：" label-width="110px">
            <course-select
              ref="CourseSelect"
              v-model.trim="filter.courseCode"
              placeholder="课程（代码）"
              clearable
            ></course-select>
          </el-form-item>
          <el-form-item label="命题老师：">
            <el-input
              v-model="filter.userName"
              placeholder="命题老师"
              clearable
            ></el-input>
          </el-form-item>
          <el-form-item label="试卷编号：">
            <paper-number-select
              ref="PaperNumberSelect"
              v-model="filter.paperNumber"
              placeholder="试卷编号"
              clearable
            ></paper-number-select>
          </el-form-item>
          <el-form-item label="命题时间：">
            <el-date-picker
              v-model="createTime"
              type="datetimerange"
              :picker-options="pickerOptions"
              range-separator="至"
              start-placeholder="命题开始时间"
              end-placeholder="命题结束时间"
              value-format="timestamp"
              align="right"
              unlink-panels
            >
            </el-date-picker>
          </el-form-item>
        </template>
        <el-form-item label-width="0px">
          <el-button
            v-if="checkPrivilege('button', 'select')"
            type="primary"
            @click="toPage(1)"
            >查询</el-button
          >
        </el-form-item>
      </el-form>
      <div class="part-box-action">
        <el-button
          v-if="checkPrivilege('button', 'addTask')"
          icon="el-icon-circle-plus-outline"
          type="primary"
          @click="toAddApply"
        >
          新建命题申请
        </el-button>
        <el-button
          v-if="checkPrivilege('button', 'ExamTaskApplyManage')"
          icon="el-icon-circle-plus-outline"
          type="primary"
          @click="toAddExamAndPrintTask"
        >
          新建任务
        </el-button>
      </div>
    </div>

    <div class="part-box part-box-pad">
      <el-table ref="TableList" :data="examTasks">
        <el-table-column
          type="index"
          label="序号"
          width="70"
          :index="indexMethod"
        ></el-table-column>
        <el-table-column
          prop="semesterName"
          label="学期"
          min-width="160"
        ></el-table-column>
        <el-table-column
          prop="examName"
          label="考试"
          min-width="160"
        ></el-table-column>
        <el-table-column
          prop="paperNumber"
          label="试卷编号"
          min-width="160"
        ></el-table-column>
        <el-table-column prop="courseName" label="课程（代码）" min-width="200">
          <template slot-scope="scope">
            {{ scope.row.courseName }}（{{ scope.row.courseCode }}）
          </template>
        </el-table-column>
        <el-table-column
          prop="userName"
          label="命题老师"
          min-width="100"
        ></el-table-column>
        <el-table-column prop="startTime" label="命题开始时间" width="170">
          <span slot-scope="scope">{{
            scope.row.startTime | timestampFilter
          }}</span>
        </el-table-column>
        <el-table-column prop="endTime" label="命题结束时间" width="170">
          <span slot-scope="scope">{{
            scope.row.endTime | timestampFilter
          }}</span>
        </el-table-column>
        <el-table-column prop="auditStatus" label="审核状态" width="100">
          <template slot-scope="scope">
            {{ scope.row.auditStatus | auditStatusFilter }}
          </template>
        </el-table-column>
        <el-table-column
          class-name="action-column"
          label="操作"
          width="160px"
          fixed="right"
        >
          <template slot-scope="scope">
            <el-button
              v-if="checkPrivilege('link', 'preview')"
              class="btn-primary"
              type="text"
              @click="toPreview(scope.row)"
              >查看详情</el-button
            >
            <el-button
              v-if="
                (scope.row.auditStatus === 'START' ||
                  scope.row.auditStatus === 'REJECT' ||
                  scope.row.auditStatus === 'CANCEL') &&
                  checkPrivilege('link', 'edit')
              "
              class="btn-primary"
              type="text"
              @click="toEdit(scope.row)"
              >立即申请</el-button
            >
            <el-button
              v-if="
                scope.row.flowType === 'NEW' &&
                  scope.row.approveCount === 2 &&
                  checkPrivilege('link', 'end')
              "
              class="btn-danger"
              type="text"
              @click="toCancel(scope.row)"
              >撤销申请</el-button
            >
            <el-button
              v-if="
                scope.row.approveFormStatus &&
                  checkPrivilege('link', 'download')
              "
              class="btn-primary"
              type="text"
              @click="toDownloadForm(scope.row)"
              >下载审批表</el-button
            >
          </template>
        </el-table-column>
      </el-table>
      <div class="part-page">
        <el-pagination
          v-if="examTasks.length"
          background
          layout="total,prev, pager, next"
          :current-page="current"
          :total="total"
          :page-size="size"
          @current-change="toPage"
        >
        </el-pagination>
      </div>
    </div>

    <!-- ModifyTaskApply -->
    <modify-task-apply
      v-if="checkPrivilege('link', 'edit') || checkPrivilege('link', 'preview')"
      ref="ModifyTaskApply"
      :edit-type="editType"
      :instance="curExamTask"
      @modified="taskModified"
    ></modify-task-apply>
    <!-- CreateTaskApply -->
    <create-task-apply
      v-if="checkPrivilege('button', 'addTask')"
      ref="CreateTaskApply"
      @modified="taskModified"
    ></create-task-apply>
    <!-- CreateExamAndPrintTask -->
    <create-exam-and-print-task
      v-if="checkPrivilege('button', 'ExamTaskApplyManage')"
      ref="CreateExamAndPrintTask"
      @modified="taskModified"
    ></create-exam-and-print-task>
    <!-- PaperApproveTable -->
    <paper-approve-table
      :instance="curExamTask"
      ref="PaperApproveTable"
    ></paper-approve-table>
  </div>
</template>

<script>
import ModifyTaskApply from "../components/ModifyTaskApply";
import CreateExamAndPrintTask from "../components/createExamAndPrintTask/CreateExamAndPrintTask";
import CreateTaskApply from "../components/CreateTaskApply";
import PaperApproveTable from "../components/PaperApproveTable";
import { AUDITING_STATUS } from "@/constants/enumerate";
import pickerOptions from "@/constants/datePickerOptions";
import { taskApplyListPage, cancelOrRestartTaskApply } from "../api";
import { mapActions } from "vuex";

export default {
  name: "task-apply-manage",
  components: {
    ModifyTaskApply,
    CreateExamAndPrintTask,
    CreateTaskApply,
    PaperApproveTable
  },
  data() {
    return {
      filter: {
        semesterId: "",
        examId: "",
        auditStatus: "",
        reviewStatus: "",
        cardRuleId: "",
        courseCode: "",
        userName: "",
        paperNumber: "",
        startTime: "",
        endTime: ""
      },
      current: 1,
      size: this.GLOBAL.pageSize,
      total: 0,
      editType: "APPLY",
      AUDITING_STATUS,
      examTasks: [],
      curExamTask: {},
      curUserId: this.$ls.get("user", { id: "" }).id,
      userRoles: this.$ls.get("user", { roleList: [] }).roleList,
      // date-picker
      createTime: [],
      pickerOptions
    };
  },
  mounted() {
    this.initData();
  },
  methods: {
    ...mapActions("exam", ["updateWaitTaskCount"]),
    async initData() {
      const cachePageInfo = this.$ls.get("cachePageInfo");
      if (cachePageInfo) {
        this.filter = this.$objAssign(this.filter, cachePageInfo.filter);
        if (this.filter.startTime && this.filter.endTime)
          this.createTime = [this.filter.startTime, this.filter.endTime];
        this.current = cachePageInfo.page;
        await this.getList();

        this.$nextTick(() => {
          const curRow = this.examTasks.find(
            item => item.id === cachePageInfo.curRowId
          );
          if (!curRow) return;
          this.toEdit(curRow);
        });
      } else {
        this.toPage(1);
      }
      this.$ls.remove("cachePageInfo");
    },
    async getList() {
      if (!this.checkPrivilege("list", "list")) return;

      const datas = {
        ...this.filter,
        pageNumber: this.current,
        pageSize: this.size
      };
      if (this.createTime) {
        datas.startTime = this.createTime[0];
        datas.endTime = this.createTime[1];
      }
      const data = await taskApplyListPage(datas);
      this.examTasks = data.records;
      this.total = data.total;
    },
    toPage(page) {
      this.current = page;
      this.getList();
    },
    toCancel(row) {
      this.$confirm("确定要撤销当前申请吗？", "提示", {
        type: "warning"
      })
        .then(async () => {
          const data = await cancelOrRestartTaskApply({
            id: row.id
          }).catch(() => {});
          if (!data) return;
          this.$message.success("操作成功！");
          this.getList();
        })
        .catch(() => {});
    },
    toEdit(row) {
      this.curExamTask = row;
      this.editType = "APPLY";
      this.$refs.ModifyTaskApply.open();
    },
    toPreview(row) {
      this.curExamTask = row;
      this.editType = "PREVIEW";
      this.$refs.ModifyTaskApply.open();
    },
    taskModified() {
      this.getList();
      this.updateWaitTaskCount(this.userRoles);
    },
    toAddApply() {
      this.$refs.CreateTaskApply.open();
    },
    toAddExamAndPrintTask() {
      this.$refs.CreateExamAndPrintTask.open();
    },
    toDownloadForm(row) {
      this.curExamTask = row;
      this.$refs.PaperApproveTable.open();
    }
  },
  beforeRouteLeave(to, from, next) {
    if (to.name === "CardEdit") {
      this.$ls.set("cachePageInfo", {
        page: this.current,
        filter: this.filter,
        curRowId: this.curExamTask.id
      });
    } else {
      this.$ls.remove("cachePageInfo");
    }
    next();
  }
};
</script>
